#include <iostream>
#include <string>
#include <vector>

# include "people-pskel.hxx"

using namespace std;

xml_schema::short_pimpl short_p;
xml_schema::string_pimpl string_p;

class Person_pimpl: public Person_pskel
{
	private:
		string firstName;
		string lastName;
		string gender;
		short mAge;
	public:
		Person_pimpl()
		{
			this->parsers(string_p, string_p, string_p, short_p);
		}
		virtual void FirstName(const std::string& rFirstName)
		{
			firstName = rFirstName;
		}
		virtual void LastName(const std::string& rLastName)
		{
			lastName = rLastName;
		}
		virtual void Gender(const std::string& rGender)
		{
			gender = rGender;
		}
		virtual void Age(short rAge)
		{
			mAge = rAge;
		}
		string GetFirstName()
		{
			return firstName;
		}
		string GetLastName()
		{
			return lastName;
		}
		string GetGender()
		{
			return gender;
		}
		short GetAge()
		{
			return mAge;
		}
};

class People_pimpl: public People_pskel
{
	private:
		Person_pimpl Person;
	public:
		People_pimpl()
		{
			this->parsers(Person);
		}
		Person_pimpl& GetPerson()
		{
			return Person;
		}
};

int main(int argC, char* argV[])
{
	People_pimpl People;
	// construction of the document parser and invocation of the complete parser
	xml_schema::document doc_p(People, "People");
	People.pre();
	doc_p.parse("people.xml");
	cout<<"First Name : "<<People.GetPerson().GetFirstName()<<endl;
	People.post_People();
}
